#[doc = "Register `IMO_ABS4` reader"]
pub struct R(crate::R<IMO_ABS4_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<IMO_ABS4_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<IMO_ABS4_SPEC>> for R {
    fn from(reader: crate::R<IMO_ABS4_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `IMO_ABS4` writer"]
pub struct W(crate::W<IMO_ABS4_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<IMO_ABS4_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<IMO_ABS4_SPEC>> for W {
    fn from(writer: crate::W<IMO_ABS4_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `ABS_TRIM_IMO` reader - IMO-irefgen output current magnitude trim"]
pub struct ABS_TRIM_IMO_R(crate::FieldReader<u8, u8>);
impl ABS_TRIM_IMO_R {
    pub(crate) fn new(bits: u8) -> Self {
        ABS_TRIM_IMO_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for ABS_TRIM_IMO_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `ABS_TRIM_IMO` writer - IMO-irefgen output current magnitude trim"]
pub struct ABS_TRIM_IMO_W<'a> {
    w: &'a mut W,
}
impl<'a> ABS_TRIM_IMO_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x3f) | (value as u8 & 0x3f);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:5 - IMO-irefgen output current magnitude trim"]
    #[inline(always)]
    pub fn abs_trim_imo(&self) -> ABS_TRIM_IMO_R {
        ABS_TRIM_IMO_R::new((self.bits & 0x3f) as u8)
    }
}
impl W {
    #[doc = "Bits 0:5 - IMO-irefgen output current magnitude trim"]
    #[inline(always)]
    pub fn abs_trim_imo(&mut self) -> ABS_TRIM_IMO_W {
        ABS_TRIM_IMO_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Value for PWR_BG_TRIM4 (ICTAT trim for IMO current reference).\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [imo_abs4](index.html) module"]
pub struct IMO_ABS4_SPEC;
impl crate::RegisterSpec for IMO_ABS4_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [imo_abs4::R](R) reader structure"]
impl crate::Readable for IMO_ABS4_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [imo_abs4::W](W) writer structure"]
impl crate::Writable for IMO_ABS4_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets IMO_ABS4 to value 0"]
impl crate::Resettable for IMO_ABS4_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
